TYPE
  tDrive       = RECORD
                   DriveNr      : BYTE ;
                   Size         : LONGINT ;
                   MaxCyl       : WORD ;
                   MaxSec       : WORD ;
                   MaxHead      : WORD ;
                   DeviceName   : STRING ;
                 END ;

VAR drv0,drv1    : tDrive ;
    drv2,drv3    : tDrive ;
    pdrv0,pdrv1  : ^tDrive ;
    pdrv2,pdrv3  : ^tDrive ;
    RAMTesttxt   : STRING ;

PROCEDURE LocateDrives ;
TYPE
    tchInfo = ARRAY[0..511] OF CHAR ;
VAR info : ARRAY[0..255] OF WORD ;
    chinfo : ^tChInfo ;
    drvinfo: ^tChInfo ;
    i      : WORD ;
BEGIN
  pDrv0:=PTR(24,Ofs(drv0)) ;
  pDrv1:=PTR(24,Ofs(drv1)) ;
  chInfo:=ADDR(info) ;
  drvinfo:=ADDR(drv0.DeviceName) ;
  drvinfo:=PTR(24,OFS(drvinfo^)) ;
  DoHDCMD(0,1,1,1,1,$EC) ;
  WaitHD ;
  WaitDRQ ;
  FOR i:=0 TO 255 DO
    info[i]:=RDW ;
  drvinfo^[0]:=#38 ;
  FOR i:=1 TO 19 DO BEGIN
    drvinfo^[i*2]:=chinfo^[53+i*2-1] ;
    drvinfo^[i*2-1]:=chinfo^[53+i*2] ;
  END ;
  pdrv0^.DriveNr:=0 ;
  pdrv0^.MaxSec:=info[56] ;
  pdrv0^.MaxCyl:=info[54] ;
  pdrv0^.MaxHead:=info[55] ;
  drvinfo:=ADDR(drv1.DeviceName) ;
  drvinfo:=PTR(24,OFS(drvinfo^)) ;
  DoHDCMD(1,1,1,1,1,$EC) ;
  WaitHD ;
  WaitDRQ ;
  FOR i:=0 TO 255 DO
    info[i]:=RDW ;
  drvinfo^[0]:=#38 ;
  FOR i:=1 TO 19 DO BEGIN
    drvinfo^[i*2]:=chinfo^[53+i*2-1] ;
    drvinfo^[i*2-1]:=chinfo^[53+i*2] ;
  END ;
  pdrv1^.DriveNr:=1 ;
  pdrv1^.MaxSec:=info[56] ;
  pdrv1^.MaxCyl:=info[54] ;
  pdrv1^.MaxHead:=info[55] ;
END ;

PROCEDURE ReadSectorABS(Drive : TDrive;nrl,nrh : WORD) ;
VAR tc,ts,th : WORD ;
BEGIN
  ASM
    CLI
    MOV AX,nrh
    DB 66h
     SHL AX,16
    MOV AX,nrl
    DB 66h
     XOR BX,BX
    MOV BX,drive.MaxHead
    DB 66h
     DIV BX
    MOV th,DX
    MOV BX,drive.MaxSec
    DB 66h
     DIV BX
    INC DX
    MOV ts,DX
    MOV tc,AX
    DB 66h
     XOR AX,AX
    STI
  END ;
  ReadSector(drive.DriveNr,th,ts,tc) ;
END ;
