CONST
  FS_FAT32_ID      = $0B ;
  FS_FAT16_ID      = $06 ;
  FS_FAT32LBA_ID   = $0C ;
  FS_FAT16LBA_ID   = $0E ;

FUNCTION FAT_CanHandleFS(Typ : BYTE) : BYTE ;
BEGIN
  If (Typ=FS_FAT32_ID) OR (Typ=FS_FAT16_ID) OR
     (Typ=FS_FAT32LBA_ID) OR (Typ=FS_FAT16LBA_ID) THEN BEGIN
    FAT_CanHandleFS:=1 ;
    WriteLine(Sysscreen,FATOK) ;
  END ELSE BEGIN
    WriteHex(1,1,posy[1],Typ) ;
    INC(posy[1]) ;
    FAT_CanHandleFS:=0 ;
  END ;
END ;

FUNCTION FAT_SizeMB(Part : WORD) : WORD ;
VAR faktor   : WORD ;
    s,c,h    : WORD ;
    spk      : WORD ;
BEGIN
  WITH PartTab^[Part] DO BEGIN
    s:=EndSek ;
    c:=EndCyl+1 ;
    h:=EndHead-StartHead+2 ;
    spk:=(s * c) ;
    FAT_SizeMB:=h * (spk SHR 11) + ((h * ((spk AND $7FF) SHR 3)) SHR 8) ;
  END ;
END ;

VAR bSek : ARRAY[0..511] OF BYTE ;

PROCEDURE FAT_Name(Part : WORD) ;
VAR s1,s2,i : WORD ;
BEGIN
  MEM[24:OFS(DRVname)]:=0 ;
  s1:=HD_MEM_Base ;
  s2:=HD_MEM_Idx ;
  HD_MEM_Base:=24 ;
  HD_MEM_Idx:=OFS(bSek) ;
  WITH PartTab^[Part] DO
    DrvReadSektor(Drive,StartHead,StartCyl,StartSek) ;
  FOR i:=0 TO 11 DO
    Concat(DRVname,bsek[$47+i]) ;
  WriteLine(SysScreen,DRVname) ;
  HD_MEM_Base:=s1 ;
  HD_MEM_Idx:=s2 ;
END ;

PROCEDURE SetFS_FAT ;
BEGIN
END ;