PROCEDURE AddPart(Drive,Typ,H,C,S,EH,EC,ES : WORD) ;
BEGIN
  Inc(LastPart) ;
  WriteDez(3,1,Posy[3],H) ;
  WriteDez(3,11,Posy[3],C) ;
  WriteDez(3,21,Posy[3],S) ;
  WriteDez(3,31,Posy[3],EH) ;
  WriteDez(3,41,Posy[3],EC) ;
  WriteDez(3,51,Posy[3],ES) ;
  INC(Posy[3]) ;
  PartTab^[LastPart].Drive:=Drive ;
  PartTab^[LastPart].StartHead:=H ;
  PartTab^[LastPart].StartSek:=S ;
  PartTab^[LastPart].StartCyl:=C ;
  PartTab^[LastPart].EndHead:=EH ;
  PartTab^[LastPart].EndSek:=ES ;
  PartTab^[LastPart].EndCyl:=EC ;
  IF FAT_CanHandleFS(Typ)=1 THEN BEGIN
    WriteDez(SysScreen,50,Posy[Sysscreen]-1,FAT_SizeMB(LastPart)) ;
  END ;
END ;

PROCEDURE AddSubPart(drive,h,c,s : WORD) ;
VAR q : WORD ;
BEGIN
  DrvTab^[drive].Interfc^.ReadSektor(DrvTab^[drive].PhysNr,h,s,c) ;
  FOR q:=0 TO 3 DO BEGIN
    IF Psek[$1BE+q*16+4]<>0 THEN BEGIN
      IF PSek[$1BE+q*16+4]=05 THEN BEGIN
        AddSubPart(drive,pSek[$1BE+q*16+1],
                     pSek[$1BE+q*16+3]+((pSek[$1BE+q*16+2] AND $C0) SHL 2),
                     pSek[$1BE+q*16+2] AND $3F) ;
        DrvTab^[drive].Interfc^.ReadSektor(DrvTab^[drive].PhysNr,0,1,0) ;
      END ;
      AddPart(drive,pSek[$1BE+q*16+4],pSek[$1BE+q*16+1],
                pSek[$1BE+q*16+3]+(pSek[$1BE+q*16+2] AND $C0) SHL 2,
                pSek[$1BE+q*16+2] AND $3F,
                pSek[$1BE+q*16+5],
                pSek[$1BE+q*16+7]+(pSek[$1BE+q*16+6] AND $C0) SHL 2,
                pSek[$1BE+q*16+6] AND $3F) ;
    END ;
  END ;
END ;

PROCEDURE ReadPartitions ;
VAR i,q : WORD ;
BEGIN
  HD_MEM_Base:=24 ;
  HD_MEM_Idx:=Ofs(PSek[0]) ;
  LastPart:=$FFFF ;
  SetGDTEntry(33,SizeOf(tPartTable),$20+100*SizeOf(tDriveEntry),31,$92,0) ;
  PartTab:=PTR(33*8,0) ;
  FOR i:=0 TO 100 DO BEGIN
    PartTab^[i].Drive:=$FF ;
    PartTab^[i].StartHead:=0 ;
    PartTab^[i].StartSek:=0 ;
    PartTab^[i].StartCyl:=0 ;
    PartTab^[i].EndHead:=0 ;
    PartTab^[i].EndSek:=0 ;
    PartTab^[i].EndCyl:=0 ;
    PartTab^[i].FS:=NIL ;
  END ;
  FOR i:=0 To LastDrv DO BEGIN
    DrvTab^[i].Interfc^.ReadSektor(DrvTab^[i].PhysNr,0,1,0) ;
    FOR q:=0 TO 3 DO BEGIN
      IF Psek[$1BE+q*16+4]<>0 THEN BEGIN
        IF PSek[$1BE+q*16+4]=05 THEN BEGIN
          AddSubPart(i,pSek[$1BE+q*16+1],
                       pSek[$1BE+q*16+3]+((pSek[$1BE+q*16+2] AND $C0) SHL 2),
                       pSek[$1BE+q*16+2] AND $3F) ;
          DrvTab^[i].Interfc^.ReadSektor(DrvTab^[i].PhysNr,0,1,0) ;
        END ;
        AddPart(i,pSek[$1BE+q*16+4],pSek[$1BE+q*16+1],
                  pSek[$1BE+q*16+3]+((pSek[$1BE+q*16+2] AND $C0) SHL 2),
                  pSek[$1BE+q*16+2] AND $3F,
                  pSek[$1BE+q*16+5],
                  pSek[$1BE+q*16+7]+((pSek[$1BE+q*16+6] AND $C0) SHL 2),
                  pSek[$1BE+q*16+6] AND $3F) ;
      END ;
    END ;
  END ;
END ;