{ um die PCI-Schnittstelle nutzen zu knnen mssen DWORDs gesendet werden knnen :=> }
{ Der Rest erklrt sich }
PROCEDURE outlPCI(port : WORD; bus,dev,wo : WORD) ; ASSEMBLER ;
ASM
  MOV AX,$8000
  OR AX,bus
  DB 66h
   SHL AX,16
  MOV AX,dev
  MOV AH,AL
  XOR AL,AL
  MOV BX,wo
  AND BX,$00FC
  OR AX,BX
  DB 66h
   XOR DX,DX
  MOV DX,port
  DB 66h
   OUT DX,AX
END ;

FUNCTION HWPCI_GetByte(Bus,dev,wo : LONGINT) : BYTE ;
VAR tmp : LONGINT ;
BEGIN
  outlPCI($CF8,bus,dev,wo) ;
  HWPCI_GetByte:=PORT[$CFC + wo AND $3] ;
END ;

FUNCTION HWPCI_GetWORD(Bus,dev,wo : LONGINT) : WORD ;
VAR tmp : LONGINT ;
BEGIN
  HWPCI_GetWORD:= HWPCI_GetByte(bus,dev,wo)
                + (HWPCI_GetByte(bus,dev,wo+1) * 256) ;
END ;

PROCEDURE HWPCI_SetByte(Bus,dev,wo,val : LONGINT) ;
BEGIN
  outlPCI($CF8,bus,dev,wo) ;
  PORT[$CFC + wo AND $3]:=val ;
END ;

PROCEDURE HWPCI_SetWORD(Bus,dev,wo,val : LONGINT) ;
BEGIN
  HWPCI_SetByte(bus,dev,wo,val) ;
  HWPCI_SetByte(bus,dev,wo + 1,val SHR 8) ;
END ;

PROCEDURE HWPCI_SetLONG(Bus,dev,wo,val : LONGINT) ;
BEGIN
  HWPCI_SetByte(bus,dev,wo,val) ;
  HWPCI_SetByte(bus,dev,wo + 1,val SHR 8) ;
  HWPCI_SetByte(bus,dev,wo + 2,val SHR 16) ;
  HWPCI_SetByte(bus,dev,wo + 3,val SHR 24) ;
END ;

PROCEDURE SVendor ;
VAR bus,dev : BYTE ;
    pos     : BYTE ;
    vid,did : WORD ;
    dtp     : WORD ;
    i       : WORD ;
BEGIN
  pos:=10 ;
  VGA_Dev:=$FF ;
  VGA_Bus:=$FF ;
  FOR bus:=0 TO 255 DO BEGIN
    FOR dev:=0 TO 255 DO BEGIN
      vid:=HWPCI_GetBYTE(bus,dev,0) ;
      vid:=vid + (HWPCI_GetBYTE(bus,dev,1) SHL 8) ;
      did:=HWPCI_GetBYTE(bus,dev,2) ;
      did:=did + (HWPCI_GetBYTE(bus,dev,3) SHL 8) ;
      dtp:=HWPCI_GetBYTE(bus,dev,10) ;
      dtp:=dtp + (HWPCI_GetBYTE(bus,dev,11) SHL 8) ;
      IF ((vid<>0) AND (vid<>$FFFF)) OR
         ((dtp<>0) AND (dtp<>$FFFF)) OR
         ((did<>0) AND (did<>$FFFF)) THEN BEGIN
        CASE dtp OF
          PCI_VGA : BEGIN
            IF (VGA_dev=$FF) AND (VGA_Bus=$FF) THEN BEGIN
              VGA_dev:=dev ;
              VGA_bus:=bus ;
              WriteText(SysScreen,3,pos,VGAdetect) ;
              WriteHex(SysScreen,40,pos,HWPCI_GetWORD(bus,dev,6)) ;
              WriteHex(SysScreen,50,pos,HWPCI_GetWORD(bus,dev,18)) ;
              WriteHex(SysScreen,54,pos,HWPCI_GetWORD(bus,dev,16)) ;
              WriteHex(SysScreen,60,pos,HWPCI_GetWORD(bus,dev,22)) ;
              WriteHex(SysScreen,64,pos,HWPCI_GetWORD(bus,dev,20)) ;
              INC(pos) ;
            END ;
          END ;
          PCI_Multimedia : BEGIN
            WriteText(SysScreen,3,pos,Multidetect) ;
            WriteHex(SysScreen,40,pos,HWPCI_GetWORD(bus,dev,6)) ;
              WriteHex(SysScreen,50,pos,HWPCI_GetWORD(bus,dev,18)) ;
              WriteHex(SysScreen,54,pos,HWPCI_GetWORD(bus,dev,16)) ;
            INC(pos) ;
          END ;
          PCI_IDE : BEGIN
            WriteText(SysScreen,3,pos,IDEdetect) ;
            WriteHex(SysScreen,40,pos,HWPCI_GetWORD(bus,dev,6)) ;
              WriteHex(SysScreen,50,pos,HWPCI_GetWORD(bus,dev,18)) ;
              WriteHex(SysScreen,54,pos,HWPCI_GetWORD(bus,dev,16)) ;
            INC(pos) ;
          END ;
          PCI_ISA : BEGIN
            WriteText(SysScreen,3,pos,ISAdetect) ;
            WriteHex(SysScreen,40,pos,HWPCI_GetWORD(bus,dev,6)) ;
              WriteHex(SysScreen,50,pos,HWPCI_GetWORD(bus,dev,18)) ;
              WriteHex(SysScreen,54,pos,HWPCI_GetWORD(bus,dev,16)) ;
            INC(pos) ;
          END ;
          PCI_Host : BEGIN
            WriteText(SysScreen,3,pos,Hostdetect) ;
            WriteHex(SysScreen,40,pos,HWPCI_GetWORD(bus,dev,6)) ;
              WriteHex(SysScreen,50,pos,HWPCI_GetWORD(bus,dev,18)) ;
              WriteHex(SysScreen,54,pos,HWPCI_GetWORD(bus,dev,16)) ;
            INC(pos) ;
          END ;
          ELSE BEGIN
            WriteHex(SysScreen,3,pos,bus) ;
            WriteHex(SysScreen,8,pos,dev) ;
            WriteHex(SysScreen,13,pos,vid) ;
            WriteHex(SysScreen,23,pos,did) ;
            WriteHex(SysScreen,32,pos,dtp) ;
            INC(pos) ;
          END ;
        END ;
      END ;
    END ;
  END ;
  WriteText(SysScreen,1,pos,EndeListing) ;
END ;
