FUNCTION TransKey(nr : BYTE) : BYTE ;
BEGIN
  CASE nr OF
    1     : TransKey:=27 ;
    2..10 : TransKey:=nr-1+48 ;
    11    : TransKey:=11 ;
    12    : Transkey:=27 ;
    14    : Transkey:=08 ;
    15    : Transkey:=09 ;
    28    : Transkey:=13 ;

    30    : Transkey:=65 ;
    48    : Transkey:=66 ;
    46    : Transkey:=67 ;
    32    : Transkey:=68 ;
    18    : Transkey:=69 ;
    33    : Transkey:=70 ;
    34    : Transkey:=71 ;
    35    : Transkey:=72 ;
    23    : Transkey:=73 ;
    36    : Transkey:=74 ;
    37    : Transkey:=75 ;
    38    : Transkey:=76 ;
    50    : Transkey:=77 ;
    49    : Transkey:=78 ;
    24    : Transkey:=79 ;
    25    : Transkey:=80 ;
    16    : Transkey:=81 ;
    19    : Transkey:=82 ;
    31    : Transkey:=83 ;
    20    : Transkey:=84 ;
    22    : Transkey:=85 ;
    47    : Transkey:=86 ;
    17    : Transkey:=87 ;
    45    : Transkey:=88 ;
    44    : Transkey:=89 ;
    21    : Transkey:=90 ;
    57    : Transkey:=32 ;
    ELSE TransKey:=nr ;
  END ;
END ;

FUNCTION PressedKey : BYTE ;
BEGIN
  WHILE MEM[128:0]=0 DO ;
  IF MEM[128:0]>0 THEN BEGIN
    PressedKey:=TransKey(MEM[128:MEM[128:0]]) ;
    DEC(MEM[128:0]) ;
  END ;
END ;

PROCEDURE ReadLine(Scrn,x,y : WORD;VAR text : STRING) ;
VAR tmp : BYTE ;
BEGIN
  MEM[24:OFS(text[0])]:=0 ;
  REPEAT
    tmp:=PressedKey ;
    IF tmp>=32 THEN BEGIN
      INC(MEM[24:OFS(text[0])]) ;
      MEM[24:OFS(text[0])+MEM[24:OFS(text[0])]]:=PressedKey ;
      WriteText(Scrn,x,y,text) ;
    END ;
  UNTIL tmp=13 ;
END ;

PROCEDURE SetLogicalScreen (nr : WORD) ; ASSEMBLER ;
ASM
  PUSH ES
  PUSH DS
  MOV AX,nr
  XOR DX,DX
  MOV BX,10
  DIV BX
  MOV AX,DX
  MOV DX,128
  MOV DS,DX
  MOV DX,[768]
  SHL DX,3
  ADD DX,136
  MOV ES,DX
  MOV DX,64
  MOV DS,DX
  XOR DI,DI
  XOR SI,SI
  MOV CX,$1000
  REP
    MOVSW

  MOV DX,64
  MOV ES,DX
  MOV DX,AX
  SHL DX,3
  ADD DX,136
  MOV DS,DX
  XOR DI,DI
  XOR SI,SI
  MOV CX,$1000
  REP
    MOVSW

  MOV DX,128
  MOV DS,DX
  MOV [768],AX

  POP DS
  POP ES
END ;